﻿using FObjBase;
using GeneralGommunication;
using Newtonsoft.Json;
using System;
using System.ComponentModel;
using System.IO;
using System.Linq;

namespace CapSensorBase
{
    //public class CapSensor : ICapSensor
    //{
    //    public event PropertyChangedEventHandler PropertyChanged;

    //    #region MARKNO
    //    const int MARKNO_SET_SAVE = 4;
    //    #endregion

    //    #region  ICapSensor

    //    public event HzMeasure2Handler HzMeasureEvent;

    //    public UInt32 Data { get; protected set; }
    //    public UInt16 IStatus { get; protected set; }
    //    public double Temperature { get; protected set; }
    //    public int Pwm { get; protected set; }

        

    //    /// <summary>
    //    /// 最后一次分频数
    //    /// </summary>
    //    public UInt16 FreqDiv { get; protected set; }

    //    /// <summary>
    //    /// 自动计算分频数
    //    /// </summary>
    //    public bool IsFdAuto { get; protected set; }

    //    public float Kp { get; protected set; }

    //    public float Ki { get; protected set; }

    //    public float Kd { get; protected set; }

    //    public double Target { get; protected set; }

    //    public bool IsPwmAuto { get; protected set; }
    //    #endregion

    //    #region ICapSensorClient
    //    /// <summary>
    //    /// 连接成功
    //    /// </summary>
    //    public bool IsConnected { get; protected set; }

    //    /// <summary>
    //    /// 重连次数
    //    /// </summary>
    //    public int ConnectCnt { get; protected set; }


    //    /// <summary>
    //    /// 已经从AD盒获取全部当前数据
    //    /// </summary>
    //    public bool IsReady { get; protected set; }

    //    /// <summary>
    //    /// AD盒地址
    //    /// </summary>
    //    public string Addr { get; set; } = "192.168.251.12:20020";
    //    #endregion

    //    public CapSensorCore Core => core;
    //    IGeneralComm comm;
    //    CapSensorCore core;
    //    static string[] propertyName_save;
    //    DateTime paramTime;

    //    static CapSensor()
    //    {
    //        propertyName_save = CapSensorJsonDb.GetMemberNames();
    //    }
    //    public CapSensor()
    //    {
    //        constructor();
    //    }
    //    void constructor()
    //    {
    //        core = new CapSensorCore();

    //        core.SendMsgEvent += (s, msg) =>
    //        {
    //            comm?.Write(msg);
    //        };

    //        core.HzMeasureEvent += Core_HzMeasureEvent;
    //        core.TemperatureMeasureEvent += Core_TemperatureMeasureEvent;

    //        core.Csm.StartMeasure();

    //        Misc.BindingOperations.SetBinding(core, nameof(core.IsConnected), this, nameof(IsConnected));

    //        this.PropertyChanged += CapSensor01_PropertyChanged;
    //    }

    //    private void CapSensor01_PropertyChanged(object sender, PropertyChangedEventArgs e)
    //    {
    //        if (e.PropertyName == nameof(IsConnected))
    //        {
    //            if (IsConnected)
    //            {
    //                ConnectCnt++;
    //                AfterConnected_init();
    //            }
    //            else
    //            {
    //                IsReady = false;
    //            }
    //        }
    //    }
    //    /// <summary>
    //    /// 连接后初始化
    //    /// </summary>
    //    void AfterConnected_init()
    //    {
    //        core.logger.Debug($"CapSensor AfterConnected_init()");

    //        //连接断开，复位 脉冲计数。。。,时间计数
    //        IsReady = false;

    //        UpdatePid();

    //        core.GetFreqDiv((asyncContext, retData) =>
    //        {
    //            var reponse = retData as GetFreqDiv_Response;
    //            IsFdAuto = reponse.isFdAuto;
    //            FreqDiv = reponse.freqDiv;

    //            //这是连接后初始化，最后一个动作
    //            AfterConntected_init_end();
    //        }, null);

    //    }

    //    void AfterConntected_init_end()
    //    {
    //        //这是连接后初始化，最后一个动作
    //        IsReady = true;

    //        paramTime = DateTime.Now;

    //        //当状态为Running时,且每秒脉冲没变，需要 查 当前的状态， 也许Stop状态少推送了
    //        PollModule.Current.Poll_Config(AfterConntected_periodic, TimeSpan.FromSeconds(1));
    //    }

    //    void AfterConntected_periodic()
    //    {
    //        if (!IsConnected)
    //            return;

    //        if (!IsReady)
    //            return;

    //        if (DateTime.Now - paramTime >= TimeSpan.FromSeconds(10))//每30秒获取全部状态
    //        {
    //            paramTime = DateTime.Now;
    //            UpdatePid();
    //            UpdateFreqDiv();
    //        }
    //    }
    //    private void Core_TemperatureMeasureEvent(object sender, TemperatureMeasureEventArgs e)
    //    {
    //        Temperature = e.temperature;
    //        Pwm = e.pwm;
    //    }

    //    private void Core_HzMeasureEvent(object sender, HzMeasureEventArgs e)
    //    {
    //        Data = e.freq;
    //        HzMeasureEvent?.Invoke(this, new HzMeasure2EventArgs
    //        {
    //            time = e.time,
    //            data = Data,
    //            pwm = Pwm,
    //            temperature = Temperature
    //        });
    //    }

    //    #region ICapSensorClient
    //    /// <summary>
    //    /// 连接
    //    /// </summary>
    //    public void Connect()
    //    {
    //        Connect(Addr);
    //    }
    //    public void Disconnect()
    //    {
    //        if (comm != null)
    //        {
    //            comm.Stop();
    //            core.ResetMsg();
    //        }
    //    }
    //    /// <summary>
    //    /// 连接 addr
    //    /// </summary>
    //    /// <param name="addr"></param>
    //    public void Connect(string addr)
    //    {
    //        Addr = addr;
    //        if (comm == null)
    //        {
    //            createComm();
    //        }
    //        else
    //        {
    //            comm.Stop();

    //            if ((Addr.ToLower().StartsWith("com") && (comm is GComm_SerialPort)) ||
    //                (!Addr.ToLower().StartsWith("com") && (comm is GComm_TcpClient)))
    //            {
    //                //不用重建
    //            }
    //            else
    //            {
    //                createComm();
    //            }
    //        }

    //        comm.Addr = addr;
    //        comm.Start();
    //    }
    //    void createComm()
    //    {
    //        if (Addr.ToLower().StartsWith("com"))
    //        {
    //            var _comm = new GComm_SerialPort();
    //            _comm.Init(new System.IO.Ports.SerialPort()
    //            {
    //                BaudRate = 19200,
    //                DataBits = 8,
    //                Parity = System.IO.Ports.Parity.None,
    //                StopBits = System.IO.Ports.StopBits.One
    //            });
    //            comm = _comm;
    //        }
    //        else
    //            comm = new GComm_TcpClient();
    //        comm.DataReceived += (sendor, msg) => core.RecMsg(msg);
    //    }
    //    /// <summary>
    //    /// 重连
    //    /// </summary>
    //    public void ReConnect()
    //    {
    //        Connect();
    //    }
    //    #endregion


    //    #region  ICapSensor
    //    public void SetP(float kp)
    //    {
    //        core.SetP(kp, (asyncContext, retData) =>
    //        {
    //            Kp = kp;
    //        }, null);
    //    }
    //    public void SetI(float ki)
    //    {
    //        core.SetI(ki, (asyncContext, retData) =>
    //        {
    //            Ki = ki;
    //        }, null);
    //    }

    //    public void SetD(float kd)
    //    {
    //        core.SetD(kd, (asyncContext, retData) =>
    //        {
    //            Kd = kd;
    //        }, null);
    //    }

    //    public void SetT(double target)
    //    {
    //        core.SetT(target, (asyncContext, retData) =>
    //        {
    //            Target = target;
    //        }, null);
    //    }


    //    /// <summary>
    //    /// frequency divider 设置分频
    //    /// </summary>
    //    public void SetFreqDiv(UInt16 fd)
    //    {
    //        core.SetFreqDiv(fd, (asyncContext, retData) =>
    //        {
    //            FreqDiv = fd;
    //        }, null);
    //    }

    //    /// <summary>
    //    /// 设置 是否自动计算分频数
    //    /// </summary>
    //    /// <param name="isAuto"></param>
    //    public void SetAutoFreqDiv(bool isAuto)
    //    {
    //        core.SetAutoFreqDiv(isAuto, (asyncContext, retData) =>
    //        {
    //            IsFdAuto = isAuto;
    //        }, null);
    //    }

    //    /// <summary>
    //    /// 强制读取分频数
    //    /// </summary>
    //    public void UpdateFreqDiv()
    //    {
    //        core.GetFreqDiv((asyncContext, retData) =>
    //        {
    //            var reponse = retData as GetFreqDiv_Response;
    //            IsFdAuto = reponse.isFdAuto;
    //            FreqDiv = reponse.freqDiv;
    //        }, null);
    //    }

    //    /// <summary>
    //    /// 强制PID控制的参数
    //    /// </summary>
    //    public void UpdatePid()
    //    {
    //        core.GetP((asyncContext, retData) => Kp = (float)retData, null);
    //        core.GetI((asyncContext, retData) => Ki = (float)retData, null);
    //        core.GetD((asyncContext, retData) => Kd = (float)retData, null);
    //        core.GetT((asyncContext, retData) => Target = (double)retData, null);
    //    }

    //    /// <summary>
    //    /// 设置PWM 自动
    //    /// </summary>
    //    /// <param name="on"></param>
    //    public void SetPwmAuto(bool on)
    //    {
    //        core.SetPwmAuto(on, (asyncContext, retData) => IsPwmAuto = on, null);
    //    }
    //    /// <summary>
    //    /// 设置PWM 值
    //    /// </summary>
    //    /// <param name="pwm"></param>
    //    public void SetPwm(int pwm)
    //    {
    //        core.SetPwm(pwm, null, null);
    //    }
    //    #endregion

    //    #region Load Save

    //    /// <summary>
    //    /// 属性改变，自动保存
    //    /// </summary>
    //    /// <param name="sender"></param>
    //    /// <param name="e"></param>
    //    private void FlyAD7_PropertyChanged2(object sender, PropertyChangedEventArgs e)
    //    {
    //        if (propertyName_save.Contains(e.PropertyName))
    //        {
    //            PollModule.Current.Poll_JustOnce(() =>
    //            {
    //                Save();
    //            }, this, MARKNO_SET_SAVE);
    //        }
    //    }


    //    string filePath = "capsensor.json";
    //    public bool Save()
    //    {
    //        return CapSensorJsonDb.Save(filePath, this);
    //    }
    //    public bool Load()
    //    {
    //        this.PropertyChanged -= FlyAD7_PropertyChanged2;

    //        bool ret = CapSensorJsonDb.Load(filePath, this);

    //        this.PropertyChanged += FlyAD7_PropertyChanged2;

    //        return ret;
    //    }

    //    #endregion
    //}

    //public class CapSensorJsonDb
    //{
    //    public static bool Save(string jsonDbPath, CapSensor src)
    //    {

    //        if (string.IsNullOrEmpty(jsonDbPath))
    //            return false;
    //        var p = new CapSensorJsonDb()
    //        {
    //            Addr = src.Addr
    //        };
    //        try
    //        {
    //            File.WriteAllText(jsonDbPath, JsonConvert.SerializeObject(p, Formatting.Indented));
    //            return true;
    //        }
    //        catch
    //        {
    //            //异常，没有json 编码失败
    //            return false;
    //        }
    //    }
    //    public static bool Load(string jsonDbPath, CapSensor src)
    //    {
    //        if (string.IsNullOrEmpty(jsonDbPath))
    //            return false;

    //        try
    //        {
    //            if (File.Exists(jsonDbPath))
    //            {
    //                string json = File.ReadAllText(jsonDbPath);
                    
    //                var p = JsonConvert.DeserializeObject<CapSensorJsonDb>(json);
    //                src.Addr = p.Addr;
    //                return true;
    //            }
    //        }
    //        catch
    //        {
    //            //异常，没有json 解码失败
    //        }
    //        return false;
    //    }

    //    public string Addr = "192.168.251.12:20020";

    //    public static string[] GetMemberNames()
    //    {
    //        var type = typeof(CapSensorJsonDb);
    //        return type.GetMembers().Select(mi => mi.Name).ToArray();
    //    }
    //}
}
