﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FLY.Thick.FilmCasting.Cap.IService
{
    /// <summary>
    /// 硬件配置参数
    /// </summary>
    public interface IInitParamService : FLY.Thick.Base.IService.IInitParamService
    {
        /// <summary>
        /// 探头 最大值
        /// </summary>
        int MaxAd { get; set; }

        /// <summary>
        /// 有拉伸前速度
        /// </summary>
        bool HasVBeforeStretching { get; set; }

        /// <summary>
        /// 拉伸前速度:1圈多少mm
        /// </summary>
        double MmOfR_VBefore { get; set; }
    }
}
