﻿using FLY.Thick.FilmCasting.Cap.IService;
using System;
using System.ComponentModel;
using System.IO;

namespace FLY.Thick.FilmCasting.Cap.Server
{
    /// <summary>
    /// 硬件配置参数
    /// </summary>
    public class InitParam : FLY.Thick.Base.Server.InitParam
    {
        /// <summary>
        /// 探头 最大值
        /// </summary>
        public int MaxAd { get; set; } = 940000;

        /// <summary>
        /// 有拉伸前速度
        /// </summary>
        public bool HasVBeforeStretching { get; set; }

        /// <summary>
        /// 拉伸前速度:1圈多少mm
        /// </summary>
        public double MmOfR_VBefore { get; set; }
    }
}
