﻿using FObjBase;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Unity;

namespace FLY.Thick.FilmCasting.Cap.UI.Server
{
    internal class Launcher
    {
        FLY.Thick.FilmCasting.Cap.Server.TDGage thkGage;
        FLY.Thick.FilmCasting.Cap.Server.OBJProxy.OBJProxys thkObjProxys;

        //用于界面
        public IUnityContainer container;

        public Launcher()
        {
            container = new UnityContainer();
        }

        public async Task Init()
        {
            string rootDir = "Gage1";
            if (!System.IO.Directory.Exists(rootDir))
            {
                System.IO.Directory.CreateDirectory(rootDir);
            }

            System.Environment.CurrentDirectory = rootDir;

            thkGage = new FLY.Thick.FilmCasting.Cap.Server.TDGage();
            await thkGage.Init();

            thkObjProxys = new FLY.Thick.FilmCasting.Cap.Server.OBJProxy.OBJProxys(0, thkGage);

            FObjSys.Currents[0].Start_Conn_Server(Misc.StringConverter.ToIPEndPoint(thkGage.sysParam.Addr));

            FObjBase.PollModule.Current.Start();


            //----------------------------------------------------------------------------
            //注册容器
            container.RegisterInstance(thkGage);
            container.RegisterInstance(thkGage.sysParam);
            container.RegisterInstance(thkGage.flyAd);
            container.RegisterInstance(thkGage.capSensor);
            container.RegisterInstance(thkGage.devSync);
        }
    }
}
