﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace FLY.Simulation
{
    public class IODefinition
    {
        /// <summary>
        /// X0 同步信号
        /// </summary>
        public const int IN_Sync = 0;

        /// <summary>
        /// X1 归0
        /// </summary>
        public const int IN_Origin = 1;
        /// <summary>
        /// X2 反向限位
        /// </summary>
        public const int IN_Minimum = 2;
        /// <summary>
        /// X3 正向限位
        /// </summary>
        public const int IN_Maximum = 3;

        /// <summary>
        /// X4 下压按钮
        /// </summary>
        public const int IN_PushDownButton = 4;

        /// <summary>
        /// X5 探头前方的保护装置
        /// </summary>
        public const int IN_SensorProtection = 5;

        /// <summary>
        /// X6 手动正转
        /// </summary>
        public const int IN_Forw = 6;
        /// <summary>
        /// X7 手动反转
        /// </summary>
        public const int IN_Backw = 7;

        /// <summary>
        /// X8 旋转架 信号0
        /// </summary>
        public const int IN_TurnSign0 = 8;

        /// <summary>
        /// X9 旋转架 信号1
        /// </summary>
        public const int IN_TurnSign1 = 9;

        /// <summary>
        /// X10 线速度 
        /// </summary>
        public const int IN_Roll = 10;

        /// <summary>
        /// Y0 同步信号
        /// </summary>
        public const int OUT_Sync = 0;

        /// <summary>
        /// Y1 探头下压
        /// </summary>
        public const int OUT_PushDown = 1;
    }
}
